Numbered parameters are broken in Ruby 3.3-dev

12/13/2023 03:33 PM - osyo (manga osyo)

Status: Closed   

Priority: Normal   

Assignee: nobu (Nobuyoshi Nakada)   

Target version: 3.3   

ruby -v: ruby 3.3.0dev (2023-12-13T13:16:11Z

master f390c51b15) [x86_64-linux]

Backport: 3.1: DONTNEED, 3.2: DONTNEED

Description

Define Numbered parameters and a method in one block and then reference Numbered parameters in another block, you will get a

SyntaxError in Ruby 3.3.

This is not a problem in Ruby 3.2.

'a'.tap do

  p _1

  def f1; end

end

'a'.tap do

  p _1

end

__END__

output:

Ruby 3.2.2 =>

"a"

"a"

Ruby 3.3.0dev(2023-12-13T13:16:11Z master f390c51b15) =>

/path/to/test.rb:

/path/to/test.rb:8: numbered parameter is already used in (SyntaxError)

/path/to/test.rb:2: outer block here

 I noticed this while checking the operation of https://bugs.ruby-lang.org/issues/18966.

I haven't checked, but https://bugs.ruby-lang.org/issues/19619 may be related.

Related issues:

Is duplicate of Ruby - Bug #18966: Strange behavior when numbered parameters ... Open

Associated revisions

Revision 92b10f5be7453aceb5863e46ac775a4ddbf83b97 - 12/15/2023 05:11 PM - nobu (Nobuyoshi Nakada)

[Bug #20062] Fixed numbered parameter syntax error

At the method definition, the local scope that saves the context of

the numbered parameters needs to be pushed before saving.

Revision 92b10f5be7453aceb5863e46ac775a4ddbf83b97 - 12/15/2023 05:11 PM - nobu (Nobuyoshi Nakada)

[Bug #20062] Fixed numbered parameter syntax error

At the method definition, the local scope that saves the context of

the numbered parameters needs to be pushed before saving.

Revision 92b10f5b - 12/15/2023 05:11 PM - nobu (Nobuyoshi Nakada)

[Bug #20062] Fixed numbered parameter syntax error

At the method definition, the local scope that saves the context of

the numbered parameters needs to be pushed before saving.
https://bugs.ruby-lang.org/issues/18966
https://bugs.ruby-lang.org/issues/19619


History

#1 - 12/13/2023 05:57 PM - k0kubun (Takashi Kokubun)

- Assignee set to nobu (Nobuyoshi Nakada)

I haven't checked, but https://bugs.ruby-lang.org/issues/19619 may be related.

 
$ ./miniruby -v /tmp/test.rb

ruby 3.3.0dev (2023-05-02T09:27:10Z master 31774bd565) [x86_64-linux]

"a"

"a"

 
$ ./miniruby -v /tmp/test.rb

ruby 3.3.0dev (2023-05-02T08:39:18Z master b15e88e0fc) [x86_64-linux]

/tmp/test.rb: /tmp/a.rb:8: numbered parameter is already used in (SyntaxError)

/tmp/test.rb:2: outer block here

 It indeed seems to have been broken since https://github.com/ruby/ruby/pull/7779.

#2 - 12/13/2023 05:59 PM - k0kubun (Takashi Kokubun)

- Backport changed from 3.0: UNKNOWN, 3.1: UNKNOWN, 3.2: UNKNOWN to 3.0: DONTNEED, 3.1: DONTNEED, 3.2: DONTNEED

#3 - 12/14/2023 12:04 AM - k0kubun (Takashi Kokubun)

- Target version set to 3.3

#4 - 12/15/2023 04:30 PM - nobu (Nobuyoshi Nakada)

https://github.com/ruby/ruby/pull/9255

#5 - 12/15/2023 04:40 PM - nobu (Nobuyoshi Nakada)

- Backport changed from 3.0: DONTNEED, 3.1: DONTNEED, 3.2: DONTNEED to 3.0: REQUIRED, 3.1: REQUIRED, 3.2: REQUIRED

#6 - 12/15/2023 04:43 PM - nobu (Nobuyoshi Nakada)

- Is duplicate of Bug #18966: Strange behavior when numbered parameters and method definition are both used in a block added

#7 - 12/15/2023 06:32 PM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

Applied in changeset git|92b10f5be7453aceb5863e46ac775a4ddbf83b97.

[Bug #20062] Fixed numbered parameter syntax error

At the method definition, the local scope that saves the context of

the numbered parameters needs to be pushed before saving.

#8 - 07/20/2024 12:52 PM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 3.0: REQUIRED, 3.1: REQUIRED, 3.2: REQUIRED to 3.1: DONTNEED, 3.2: DONTNEED

I believe this issue is not the case on ruby_3_2. The test case added was passed with current ruby_3_2 branch.
